10     DIM File_name$[20]
20     INTEGER Result
30     CLEAR SCREEN
40     !
50     ASSIGN @Agt4288a TO 717
60     !
70     File_name$="Cmp_data"
80     !
90     OUTPUT @Agt4288a;":SYST:PRES"
100    !
110    Result=FNCompen(@Agt4288a,"Open",.00002)
120    IF Result<>0 THEN Prog_end
130    Result=FNCompen(@Agt4288a,"Short",20)
140    IF Result<>0 THEN Prog_end
150    Result=FNCompen(@Agt4288a,"Load",.2)
160    IF Result<>0 THEN Prog_end
170    !
180    CALL Save_comp_data(@Agt4288a,File_name$)
190    !
200 Prog_end:  END
210    !=============================================
220    ! Compensation Data Measurement Function
230    !=============================================
240  DEF FNCompen(@Agt4288a,Standard$,Limit)
250    DIM Inp_char$[9],Buff$[9],Std$[9],Err$[50]
260    REAL Curr_freq,Freq(1:2),Para1,Para2,Zm,Ym,Gm,Bm
270    REAL Cpref,Dref,Zref,Gref,Bref
280    INTEGER Err_flag
290    OUTPUT @Agt4288a;":SOUR:FREQ?"
300    ENTER @Agt4288a;Curr_freq
310    Freq(1)=1.E+3
320    Freq(2)=1.E+6
330    Load_para$="CPD"
340    OUTPUT @Agt4288a;":STAT:OPER:ENAB 128"
350    OUTPUT @Agt4288a;"*SRE 128"
360    SELECT Standard$
370      CASE "Open"
380        Std$="STAN1"
390      CASE "Short"
400        Std$="STAN2"
410      CASE "Load"
420        Std$="STAN3"
430        CALL Inp_data("Load(Cp) Value @1kHz",Load1(1))
440        CALL Inp_data("Load(D)  Value @1kHz",Load2(1))
450        CALL Inp_data("Load(Cp) Value @1MHz",Load1(2))
460        CALL Inp_data("Load(D)  Value @1MHz",Load2(2))
470        OUTPUT @Agt4288a;":CORR:CKIT:STAN3:FORM "&Load_para$
480        FOR I=1 TO 2
490          OUTPUT @Agt4288a;":SOUR:FREQ ";Freq(I)
500          OUTPUT @Agt4288a;":CORR:CKIT:STAN3 ";Load1(I);",";Load2(I)
510        NEXT I
520    END SELECT
530 Compen_meas:  !
540    PRINT "Set "&Standard$&"-Connection."
550    INPUT "OK? [Y/N]",Inp_char$
560    IF UPC$(Inp_char$)="Y" THEN 
570      FOR I=1 TO 2
580        PRINT "Frequency:";Freq(I)
590        OUTPUT @Agt4288a;":SOUR:FREQ ";Freq(I)
600        OUTPUT @Agt4288a;"*CLS"
610        OUTPUT @Agt4288a;"*OPC?"
620        ENTER @Agt4288a;Buff$
630        ! Measurement
640        ON INTR 7 GOTO Meas_end
650        ENABLE INTR 7;2
660        OUTPUT @Agt4288a;":CORR:COLL "&Std$
670 Meas_wait:  GOTO Meas_wait
680 Meas_end:  OFF INTR 7
690        ! Error Check
700        OUTPUT @Agt4288a;":SYST:ERR?"
710        ENTER @Agt4288a;Err_no,Err$
720        IF Err_no<>0 THEN 
730          PRINT "Error: "&Err$
740          GOTO Compen_meas
750        END IF
760        ! Data Check
770        OUTPUT @Agt4288a;":CORR:DATA? "&Std$
780        ENTER @Agt4288a;Para1,Para2
790        Err_flag=0
800        SELECT Standard$
810          CASE "Open"
820            Ym=SQRT(Para1*Para1+Para2*Para2)
830            PRINT "G =";Para1,"B =";Para2,"|Y| =";Ym
840            IF Ym>=Limit THEN Err_flag=1
850          CASE "Short"
860            Zm=SQRT(Para1*Para1+Para2*Para2)
870            PRINT "R =";Para1,"X =";Para2,"|Z| =";Zm
880            IF Zm>=Limit THEN Err_flag=1
890          CASE "Load"
900            OUTPUT @Agt4288a;":CORR:CKIT:STAN3?"
910            ENTER @Agt4288a;Cpref,Dref
920            Bref=2*PI*Freq(I)*Cpref
930            Gref=Bref*Dref
940            Zref=1/SQRT(Gref*Gref+Bref*Bref)
950            Bm=2*PI*Freq(I)*Para1
960            Gm=Bm*Para2
970            Zm=1/SQRT(Gm*Gm+Bm*Bm)
980            PRINT "Cpref=";Cpref,"Dref=";Dref,"|Zref| =";Zref
990            PRINT "Cp   =";Para1,"D   =";Para2,"|Z|    =";Zm
1000           IF ABS((Zm-Zref)/Zref)>=Limit THEN Err_flag=1
1010       END SELECT
1020       IF Err_flag<>0 THEN 
1030         PRINT "Out of limit!!"
1040         GOTO Compen_meas
1050       END IF
1060     NEXT I
1070     PRINT Standard$&" Data Measurement Complete"
1080     OUTPUT @Agt4288a;":SOUR:FREQ ";Curr_freq
1090     RETURN 0
1100   ELSE
1110     PRINT "Program Interruption"
1120     OUTPUT @Agt4288a;":SOUR:FREQ ";Curr_freq
1130     RETURN -1
1140   END IF
1150 FNEND
1160   !=============================================
1170   ! Compensation Data File Save Function
1180   !=============================================
1190 SUB Save_comp_data(@Agt4288a,File_name$)
1200   DIM Load_para$[5]
1210   REAL Freq(1:2),Open(1:2,1:2),Shor(1:2,1:2)
1220   REAL Load(1:2,1:2),Load_ref(1:2,1:2)
1230   INTEGER Cable,F_shift,Fr,Std
1240   OUTPUT @Agt4288a;":CAL:CABL?"
1250   ENTER @Agt4288a;Cable
1260   OUTPUT @Agt4288a;":SYST:FSH?"
1270   ENTER @Agt4288a;F_shift
1280   !
1290   Freq(1)=1.E+3
1300   Freq(2)=1.E+6
1310   FOR Fr=1 TO 2
1320     OUTPUT @Agt4288a;":SOUR:FREQ ";Freq(Fr)
1330     OUTPUT @Agt4288a;":CORR:DATA? STAN1"
1340     ENTER @Agt4288a;Open(Fr,1),Open(Fr,2)
1350     OUTPUT @Agt4288a;":CORR:DATA? STAN2"
1360     ENTER @Agt4288a;Shor(Fr,1),Shor(Fr,2)
1370     OUTPUT @Agt4288a;":CORR:DATA? STAN3"
1380     ENTER @Agt4288a;Load(Fr,1),Load(Fr,2)
1390     OUTPUT @Agt4288a;":CORR:CKIT:STAN3?"
1400     ENTER @Agt4288a;Load_ref(Fr,1),Load_ref(Fr,2)
1410   NEXT Fr
1420   OUTPUT @Agt4288a;":CORR:CKIT:STAN3:FORM?"
1430   ENTER @Agt4288a;Load_para$
1440   !
1450   ON ERROR GOTO Skip_purge
1460   PURGE File_name$
1470 Skip_purge: OFF ERROR 
1480   CREATE File_name$,1
1490   ASSIGN @File TO File_name$
1500   OUTPUT @File;Cable,F_shift,Open(*),Shor(*),Load(*),Load_ref(*),Load_para$
1510   ASSIGN @File TO *
1520   PRINT "Save file name: "&File_name$
1530 SUBEND
1540   !=============================================
1550   ! Data Input Function
1560   !=============================================
1570 SUB Inp_data(Mes$,Inp_val)
1580   DIM Inp_char$[30]
1590   ON ERROR GOTO Inp_start
1600 Inp_start:!
1610   PRINT "Input "&Mes$
1620   INPUT "Value?",Inp_char$
1630   Inp_val=VAL(UPC$(Inp_char$))
1640   PRINT "Input Value: ";Inp_val
1650   INPUT "OK? [Y/N]",Inp_char$
1660   IF UPC$(Inp_char$)<>"Y" THEN Inp_start
1670   OFF ERROR 
1680 SUBEND
5000   !*************************************************
5010   !* DESCRIPTION:  Agilent 4288A Sample Program
5020   !*
5030   !* AUTHOR:       Agilent Technologies Japan, Ltd.
5040   !* CREATED:      12/1/2000
5050   !* PROGRAM NAME: compen.bas
5060   !* REVISION:     A.01.00
5070   !*
5080   !*     Copyright (c) Agilent Technologies,
5090   !*              All rights reserved.
5100   !*
5110   !*
5120   !*  Customer shall have the personal, non-
5130   !* transferable rights to use, copy or modify
5140   !* this SAMPLE PROGRAM for Customer's internal
5150   !* operations. Customer shall use the SAMPLE
5160   !* PROGRAM solely and exclusively for its own
5170   !* purpose and shall not license, lease, market
5180   !* or distribute the SAMPLE PROGRAM or
5190   !* modification or any part thereof.
5200   !*
5210   !*  Agilent Technologies shall not be liable for
5220   !* the quality, performance or behavior of the
5230   !* SAMPLE PROGRAM. Agilent Technologies especially
5240   !* disclaims that the operation of the SAMPLE
5250   !* PROGRAM shall be uninterrupted or error free.
5260   !* This SAMPLE PROGRAM is provided AS IS.
5270   !*
5280   !*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
5290   !* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
5300   !* A PARTICULAR PURPOSE.
5310   !*
5320   !*  Agilent Technologies shall not be liable for
5330   !* any infringement of any patent, trademark,
5340   !* copyright or other proprietary rights by the
5350   !* SAMPLE PROGRAM or its use. Agilent Technologies
5360   !* does not warrant that the SAMPLE PROGRAM is
5370   !* free from infringements or such rights of third
5380   !* parties. However, Agilent Technologies will not
5390   !* knowingly infringe or deliver a software that
5400   !* infringes the patent, trademark, copyright or
5410   !* other proprietary right of a third party.
5420   !*
5430   !*************************************************
