10     INTEGER Ch,Result
20     CLEAR SCREEN
30     !
40     ASSIGN @Agt4288a TO 717
50     !
60     OUTPUT @Agt4288a;":SYST:PRES"
70     OUTPUT @Agt4288a;":CORR:MULT ON"
80     OUTPUT @Agt4288a;":CORR:MULT:CKIT:STAN3 ON"
90     OUTPUT @Agt4288a;":DISP:TEXT2:PAGE 5"
100    !
110    FOR Ch=0 TO 3
120      PRINT "## Channel No.: ";Ch;"##"
130      OUTPUT @Agt4288a;":CORR:MULT:CHAN ";Ch
140      Result=FNCompen(@Agt4288a,"Open",.00002)
150      IF Result<>0 THEN Prog_end
160    NEXT Ch
170    FOR Ch=0 TO 3
180      PRINT "## Channel No.: ";Ch;"##"
190      OUTPUT @Agt4288a;":CORR:MULT:CHAN ";Ch
200      Result=FNCompen(@Agt4288a,"Short",20)
210      IF Result<>0 THEN Prog_end
220    NEXT Ch
230    FOR Ch=0 TO 3
240      PRINT "## Channel No.: ";Ch;"##"
250      OUTPUT @Agt4288a;":CORR:MULT:CHAN ";Ch
260      Result=FNCompen(@Agt4288a,"Load",.2)
270      IF Result<>0 THEN Prog_end
280    NEXT Ch
290    !
300 Prog_end:  END
310    !=============================================
320    ! Compensation Data Measurement Function
330    !=============================================
340  DEF FNCompen(@Agt4288a,Standard$,Limit)
350    DIM Inp_char$[9],Buff$[9],Std$[9],Err$[50]
360    REAL Curr_freq,Freq(1:2),Para1,Para2,Zm,Ym,Gm,Bm
370    REAL Cpref,Dref,Zref,Gref,Bref
380    INTEGER Err_flag
390    OUTPUT @Agt4288a;":SOUR:FREQ?"
400    ENTER @Agt4288a;Curr_freq
410    Freq(1)=1.E+3
420    Freq(2)=1.E+6
430    Load_para$="CPD"
440    OUTPUT @Agt4288a;":STAT:OPER:ENAB 128"
450    OUTPUT @Agt4288a;"*SRE 128"
460    SELECT Standard$
470      CASE "Open"
480        Std$="STAN1"
490      CASE "Short"
500        Std$="STAN2"
510      CASE "Load"
520        Std$="STAN3"
530        CALL Inp_data("Load(Cp) Value @1kHz",Load1(1))
540        CALL Inp_data("Load(D)  Value @1kHz",Load2(1))
550        CALL Inp_data("Load(Cp) Value @1MHz",Load1(2))
560        CALL Inp_data("Load(D)  Value @1MHz",Load2(2))
570        OUTPUT @Agt4288a;":CORR:CKIT:STAN3:FORM "&Load_para$
580        FOR I=1 TO 2
590          OUTPUT @Agt4288a;":SOUR:FREQ ";Freq(I)
600          OUTPUT @Agt4288a;":CORR:CKIT:STAN3 ";Load1(I);",";Load2(I)
610        NEXT I
620    END SELECT
630 Compen_meas:  !
640    PRINT "Set "&Standard$&"-Connection."
650    INPUT "OK? [Y/N]",Inp_char$
660    IF UPC$(Inp_char$)="Y" THEN 
670      FOR I=1 TO 2
680        PRINT "Frequency:";Freq(I)
690        OUTPUT @Agt4288a;":SOUR:FREQ ";Freq(I)
700        OUTPUT @Agt4288a;"*CLS"
710        OUTPUT @Agt4288a;"*OPC?"
720        ENTER @Agt4288a;Buff$
730        ! Measurement
740        ON INTR 7 GOTO Meas_end
750        ENABLE INTR 7;2
760        OUTPUT @Agt4288a;":CORR:COLL "&Std$
770 Meas_wait:  GOTO Meas_wait
780 Meas_end:  OFF INTR 7
790        ! Error Check
800        OUTPUT @Agt4288a;":SYST:ERR?"
810        ENTER @Agt4288a;Err_no,Err$
820        IF Err_no<>0 THEN 
830          PRINT "Error: "&Err$
840          GOTO Compen_meas
850        END IF
860        ! Data Check
870        OUTPUT @Agt4288a;":CORR:DATA? "&Std$
880        ENTER @Agt4288a;Para1,Para2
890        Err_flag=0
900        SELECT Standard$
910          CASE "Open"
920            Ym=SQRT(Para1*Para1+Para2*Para2)
930            PRINT "G =";Para1,"B =";Para2,"|Y| =";Ym
940            IF Ym>=Limit THEN Err_flag=1
950          CASE "Short"
960            Zm=SQRT(Para1*Para1+Para2*Para2)
970            PRINT "R =";Para1,"X =";Para2,"|Z| =";Zm
980            IF Zm>=Limit THEN Err_flag=1
990          CASE "Load"
1000           OUTPUT @Agt4288a;":CORR:CKIT:STAN3?"
1010           ENTER @Agt4288a;Cpref,Dref
1020           Bref=2*PI*Freq(I)*Cpref
1030           Gref=Bref*Dref
1040           Zref=1/SQRT(Gref*Gref+Bref*Bref)
1050           Bm=2*PI*Freq(I)*Para1
1060           Gm=Bm*Para2
1070           Zm=1/SQRT(Gm*Gm+Bm*Bm)
1080           PRINT "Cpref=";Cpref,"Dref=";Dref,"|Zref| =";Zref
1090           PRINT "Cp   =";Para1,"D   =";Para2,"|Z|    =";Zm
1100           IF ABS((Zm-Zref)/Zref)>=Limit THEN Err_flag=1
1110       END SELECT
1120       IF Err_flag<>0 THEN 
1130         PRINT "Out of limit!!"
1140         GOTO Compen_meas
1150       END IF
1160     NEXT I
1170     PRINT Standard$&" Data Measurement Complete"
1180     OUTPUT @Agt4288a;":SOUR:FREQ ";Curr_freq
1190     RETURN 0
1200   ELSE
1210     PRINT "Program Interruption"
1220     OUTPUT @Agt4288a;":SOUR:FREQ ";Curr_freq
1230     RETURN -1
1240   END IF
1250 FNEND
1260   !=============================================
1270   ! Data Input Function
1280   !=============================================
1290 SUB Inp_data(Mes$,Inp_val)
1300   DIM Inp_char$[30]
1310   ON ERROR GOTO Inp_start
1320 Inp_start:!
1330   PRINT "Input "&Mes$
1340   INPUT "Value?",Inp_char$
1350   Inp_val=VAL(UPC$(Inp_char$))
1360   PRINT "Input Value: ";Inp_val
1370   INPUT "OK? [Y/N]",Inp_char$
1380   IF UPC$(Inp_char$)<>"Y" THEN Inp_start
1390   OFF ERROR 
1400 SUBEND
5000   !*************************************************
5010   !* DESCRIPTION:  Agilent 4288A Sample Program
5020   !*
5030   !* AUTHOR:       Agilent Technologies Japan, Ltd.
5040   !* CREATED:      12/1/2000
5050   !* PROGRAM NAME: multi.bas
5060   !* REVISION:     A.01.00
5070   !*
5080   !*     Copyright (c) Agilent Technologies,
5090   !*              All rights reserved.
5100   !*
5110   !*
5120   !*  Customer shall have the personal, non-
5130   !* transferable rights to use, copy or modify
5140   !* this SAMPLE PROGRAM for Customer's internal
5150   !* operations. Customer shall use the SAMPLE
5160   !* PROGRAM solely and exclusively for its own
5170   !* purpose and shall not license, lease, market
5180   !* or distribute the SAMPLE PROGRAM or
5190   !* modification or any part thereof.
5200   !*
5210   !*  Agilent Technologies shall not be liable for
5220   !* the quality, performance or behavior of the
5230   !* SAMPLE PROGRAM. Agilent Technologies especially
5240   !* disclaims that the operation of the SAMPLE
5250   !* PROGRAM shall be uninterrupted or error free.
5260   !* This SAMPLE PROGRAM is provided AS IS.
5270   !*
5280   !*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
5290   !* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
5300   !* A PARTICULAR PURPOSE.
5310   !*
5320   !*  Agilent Technologies shall not be liable for
5330   !* any infringement of any patent, trademark,
5340   !* copyright or other proprietary rights by the
5350   !* SAMPLE PROGRAM or its use. Agilent Technologies
5360   !* does not warrant that the SAMPLE PROGRAM is
5370   !* free from infringements or such rights of third
5380   !* parties. However, Agilent Technologies will not
5390   !* knowingly infringe or deliver a software that
5400   !* infringes the patent, trademark, copyright or
5410   !* other proprietary right of a third party.
5420   !*
5430   !*************************************************
